"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.furlong = void 0;
const metrics = __importStar(require("./metrics"));
const utils_1 = require("./utils");
const furlong = (d) => {
    let distFn = d === undefined ? metrics['euclidean'] : metrics[d];
    let fx;
    let fy;
    function g(x, y) {
        return g.distance(x, y);
    }
    g.distance = function (x, y) {
        if (x.length !== y.length)
            throw new RangeError('Vectors must be of equivalent length');
        const hasAccessors = fx !== undefined && fy !== undefined;
        const isVecs = (0, utils_1.isVec)(x) && (0, utils_1.isVec)(y);
        const notVecs = !(0, utils_1.isVec)(x) && !(0, utils_1.isVec)(y);
        if (isVecs) {
            x = x;
            y = y;
            return distFn(x, y);
        }
        else if (hasAccessors && notVecs) {
            x = x;
            y = y;
            fx = fx;
            fy = fy;
            return distFn(x.map(fx), y.map(fy));
        }
        else
            return 0;
    };
    g.x = function (fn) {
        fx = fn;
        return g;
    };
    g.y = function (fn) {
        fy = fn;
        return g;
    };
    g.func = function (fn) {
        distFn = fn;
        return g;
    };
    return g;
};
exports.furlong = furlong;
